Option Explicit

'Error codes returned from XTALUDL.DLL:
'32000 : Not a Crystal Report (or a version not supported).
'32001 : Bad path or file name. Couldn't get handle to file.
'32002 : No Margin Info. Can't set, or nothing to get.
'32003 : No Label Info (No fields placed on report)
'32010 : Couldn't set fontface: no printer in WIN.INI or couldn't get
'        a device context for printer, or invalid facename passed.

Global Const XTAL_INVALID_FILEFORMAT = 32000
Global Const XTAL_BAD_FILENAME = 32001
Global Const XTAL_NO_MARGININFO = 32002
Global Const XTAL_NO_LABELINFO = 32003
Global Const XTAL_FACENAME_ERROR = 32010

Global Const XTAL_SET_LABEL = 2
Global Const XTAL_GET_LABEL = 1

Type LABEL_DIMENSIONS
    leftMargin As Single
    rightMargin As Single
    topMargin As Single
    bottomMargin As Single
    labelWidth As Single
    labelHeight As Single
    HorzGap As Single
    VertGap As Single
    direction As Integer
    tester As Single
End Type

'XTALUDL.DLL declarations
Declare Sub GetSetLabelDimensions Lib "XTALUDL.DLL" (ByVal lpszFileName$, lpDimensions As LABEL_DIMENSIONS, ByVal nAction%, lpErrcode%)
Declare Sub GetreportTitle Lib "XTALUDL.DLL" (ByVal lpszFileName$, ByVal lpszReportTitle$, ByVal lpszReportComment$, lpErrcode%)
Declare Sub SetFontAll Lib "XTALUDL.DLL" (ByVal lpszFileName$, ByVal lpszFaceName$, ByVal nFontsize%, lpErrcode%)



'From constant.txt:

'Fonts Dialog Flags
Global Const CF_SCREENFONTS = &H1&
Global Const CF_PRINTERFONTS = &H2&
Global Const CF_BOTH = &H3&
Global Const CF_SHOWHELP = &H4&
Global Const CF_INITTOLOGFONTSTRUCT = &H40&
Global Const CF_USESTYLE = &H80&
Global Const CF_EFFECTS = &H100&
Global Const CF_APPLY = &H200&
Global Const CF_ANSIONLY = &H400&
Global Const CF_NOVECTORFONTS = &H800&
Global Const CF_NOSIMULATIONS = &H1000&
Global Const CF_LIMITSIZE = &H2000&
Global Const CF_FIXEDPITCHONLY = &H4000&
Global Const CF_WYSIWYG = &H8000&         'must also have CF_SCREENFONTS & CF_PRINTERFONTS
Global Const CF_FORCEFONTEXIST = &H10000
Global Const CF_SCALABLEONLY = &H20000
Global Const CF_TTONLY = &H40000
Global Const CF_NOFACESEL = &H80000
Global Const CF_NOSTYLESEL = &H100000
Global Const CF_NOSIZESEL = &H200000

'File Open/Save Dialog Flags
Global Const OFN_READONLY = &H1&
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_NOCHANGEDIR = &H8&
Global Const OFN_SHOWHELP = &H10&
Global Const OFN_NOVALIDATE = &H100&
Global Const OFN_ALLOWMULTISELECT = &H200&
Global Const OFN_EXTENSIONDIFFERENT = &H400&
Global Const OFN_PATHMUSTEXIST = &H800&
Global Const OFN_FILEMUSTEXIST = &H1000&
Global Const OFN_CREATEPROMPT = &H2000&
Global Const OFN_SHAREAWARE = &H4000&
Global Const OFN_NOREADONLYRETURN = &H8000&

'Common Dialog Control
'Action Property
Global Const DLG_FILE_OPEN = 1
Global Const DLG_FILE_SAVE = 2
Global Const DLG_COLOR = 3
Global Const DLG_FONT = 4
Global Const DLG_PRINT = 5
Global Const DLG_HELP = 6

